#include"scmc.h"
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<math.h>
#include<time.h>
#define PI 3.14159265

SCMC_MAIN

int16_t gridunit=leftwallflametrap;
int16_t uncenter=siegetankturret_tankmode;

int16_t dc_state=0;
int16_t dc_rand=1;
int16_t dc_grid[2][3]={{2,3,4},{5,6,7}};
int16_t dc_temp[3]={8,9,10};
int16_t dc_order=11;
int16_t dc_pos[2]={12,13};
int16_t dc_dir=14;
int16_t dc_speed_mag=15;
int16_t dc_speed[2]={16,17};

int8_t hyper=0;
int8_t _rand[6]={1,2,3,4,5,6};
int8_t sgen[3]={7,8,9};

int tile=32;
int dim=128;
int map=tile*128;
int space=tile*16;
int area=tile*96;
int accu=8;
int gran=8;
int angle=128;
int agran=8;
int maxspeed=16;
int adj_y=tile/accu*1+1;
int dc_bits=8*4;

int32_t qc=1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2;

int16_t _units[7]={devouringone,jimraynor_vulture,fenix_dragoon,edmundduke_tankmode,torrasque,warbringer,darkarchon};
int indices[7]={1,1,1,2,1,11,1};

char wavs[7][5][64]={
	{
		"sound\\Zerg\\Zergling\\ZZeWht00.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht01.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht02.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht03.WAV",
		"sound\\Zerg\\Zergling\\ZZePss00.WAV",
	},
	{
		"sound\\Terran\\RAYNORV\\URVWht00.WAV",
		"sound\\Terran\\RAYNORV\\URVWht01.WAV",
		"sound\\Terran\\RAYNORV\\URVWht02.WAV",
		"sound\\Terran\\RAYNORV\\URVWht03.WAV",
		"sound\\Terran\\RAYNORV\\URVPss00.WAV",
	},
	{
		"sound\\Protoss\\FENIXD\\UFdWht00.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht01.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht02.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht03.WAV",
		"sound\\Protoss\\FENIXD\\UFdPss00.WAV",
	},
	{
		"sound\\Terran\\DUKET\\UDTWht00.WAV",
		"sound\\Terran\\DUKET\\UDTWht01.WAV",
		"sound\\Terran\\DUKET\\UDTWht02.WAV",
		"sound\\Terran\\DUKET\\UDTWht03.WAV",
		"sound\\Terran\\DUKET\\UDTPss00.WAV",
	},
	{
		"sound\\Zerg\\Ultra\\ZUlWht00.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht01.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht02.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht03.WAV",
		"sound\\Zerg\\Ultra\\ZUlPss00.WAV",
	},
	{
		"sound\\Protoss\\TRILOBYTE\\PTrWht00.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht01.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht02.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht03.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrPss00.WAV",
	},
	{
		"sound\\Protoss\\DARCHON\\PDaWht00.WAV",
		"sound\\Protoss\\DARCHON\\PDaWht01.WAV",
	},
};

char desc[7][256]={
	CENTER "Devouring One Speed: Weight:",
	CENTER "Jim Raynor Speed: Weight:",
	CENTER "Fenix Speed: Weight:",
	CENTER "Edmund Duke Speed: Weight:",
	CENTER "Torrasque Speed: Weight:",
	CENTER "Warbringer Speed: Weight:",
	CENTER "Dark Archon Speed: Weight:",
};
void scmc(void){
	*erab=badlands;

	FILE *bmp=fopen("starkart6.bmp","rb");
	fseek(bmp,0,SEEK_END);
	long bmps=ftell(bmp);
	rewind(bmp);
	char *bmpb=(char *)malloc(bmps);
	fread(bmpb,1,bmps,bmp);
	uint32_t bmpdo=*(uint32_t *)(bmpb+10);
	uint16_t (*mb)[dim][dim]=(uint16_t (*)[dim][dim])mtxmb;
	for(int a=0;a<dim;a++){
		for(int b=0;b<dim;b++){
			uint32_t p=*(uint32_t *)(bmpb+bmpdo+dim*3*a+3*b)&0x00FFFFFF;
			if(p==0x000000){
				(*mb)[dim-1-a][b]=16*1;
			}else if(p==0xFF0000){
				(*mb)[dim-1-a][b]=417*16;
			}else if(p==0x00FF00){
				(*mb)[dim-1-a][b]=12*16;
			}else if(p==0x0000FF){
				(*mb)[dim-1-a][b]=0;
			}else if(p==0xFFFFFF){
				(*mb)[dim-1-a][b]=4*16;
			}
		}
	}
	free(bmpb);
	fclose(bmp);

	for(int a=0;a<6;a++){
		thg2(p1,231,tile*(72+a),tile*46,1<<12);
	}
	
	strs=2;
	*strc=0;
	
	for(int a=1;a<1+11*6;a++){
		trigp(1<<f1);
		deaths(161877,0,exactly,6455960-336*(a-1));
		char s[100];
		sprintf(s,"%d",a);
		displaytextmessagea(str(s));
	}

	sprpb->n=str("StarKart");
	{
		time_t t;
		time(&t);
		struct tm *tm=localtime(&t);
		char s[256];
		strftime(s,sizeof(s),"Made by: x86\n"
							 "For the 2012 SEN One Week Mapping Contest\n"
							 "Compiled %A, %B %d, %Y",tm);
							 
		sprpb->d=str(s);
	}

	memset(unixb,0,sizeof(*unixb));
	memset(upgxb,0,sizeof(*upgxb));
	memset(tecxb,0,sizeof(*tecxb));
	memset(pupxb,0,sizeof(*pupxb));
	memset(ptexb,0,sizeof(*ptexb));

	unixb->s[_units[0]]=str(DEFAULT);
	unixb->hp[_units[0]]=256*1+9;
	unixb->s[_units[1]]=str(DEFAULT);
	unixb->hp[_units[1]]=256*1+9;
	unixb->s[_units[2]]=str(DEFAULT);
	unixb->hp[_units[2]]=256*1+9;
	unixb->s[_units[3]]=str(DEFAULT);
	unixb->hp[_units[3]]=256*1+9;
	unixb->s[_units[4]]=str(DEFAULT);
	unixb->hp[_units[4]]=256*1+9;
	unixb->s[_units[5]]=str(DEFAULT);
	unixb->hp[_units[5]]=256*1+9;
	unixb->s[_units[6]]=str(DEFAULT);
	unixb->hp[_units[6]]=256*1+9;
	
	ptexb->a[p1][tech_burrowing]=1;
	ptexb->r[p1][tech_burrowing]=1;

	memset(ownrb,0,sizeof(*ownrb));
	memset(forcb,0,sizeof(*forcb));
	memset(sideb,0,sizeof(*sideb));
	forcb->s[f1-f1]=str("Racers");
	//forcb->f[f1-f1]=forc_allied|forc_random;
	for(int a=0;a<6;a++){
		//(*ownrb)[p2+a]=ownr_human;
		(*ownrb)[p2+a]=ownr_computer;
		forcb->p[p2+a]=f1-f1;
		(*sideb)[p2+a]=side_random;
	}
	for(int a=0;a<2;a++){
		int8_t p[2]={p1,p8};
		(*ownrb)[p[a]]=ownr_computer2;
		forcb->p[p[a]]=f2-f1;
	}

	(*ownrb)[p2]=ownr_human;

	//locs
	memset(mrgnb,0,sizeof(*mrgnb)*mrgnn);
	uint8_t anywhere=mrgn(0,0,map,map,0);
	uint8_t gen[2];
	for(int a=0;a<2;a++){
		gen[a]=mrgn(0,0,0,0,0);
	}
	uint8_t grid_x_static[4];
	for(int a=0;a<4;a++){
		int32_t x=space+accu/2+accu*(area/accu/4*(1+a)-1);
		int32_t y=map-64;
		grid_x_static[a]=mrgn(x,y,x,y,0);
	}
	uint8_t grid_x[4];
	grid_x[0]=mrgn(1,0,0,0,0);
	for(int a=0;a<3;a++){
		grid_x[1+a]=mrgn(0,0,2+(accu*((1<<2*(a+1))-2))*2,0,0);
	}
	uint8_t shift=mrgn(0,0,0,map*2,0);
	uint8_t grid_y[area/accu/2];
	for(int a=0;a<area/accu/2;a++){
		grid_y[a]=mrgn(0,0,0,(space+accu/2+accu*a)*2,0);
	}
	uint8_t topleft=mrgn(0,0,tile,tile,0);
	uint8_t norm=mrgn(space,space,space+area,space+area,0); 
	uint8_t dirt=mrgn(space,space,space+area,space+area,medium);
	uint8_t pos[6];
	for(int a=0;a<6;a++){
		pos[a]=mrgn(0,0,0,0,0);
	}
	
	//start locs
	for(int a=0;a<8;a++){
		unit(p1+a,startlocation,0,0,0,0,0,0,0,0);
	}
	//unit(p2,wraith,map/2,map/2,0,0,0,0,0,invincible);
	//index fillers
	for(int a=0;a<1+(11*6);a++){
		unit(p1,zergling,map/2,map/2,0,0,0,0,0,burrowed);
	}
	//map revealers
	for(int a=0;a<7;a++){
		int b=1+6;
		int c=7*32;
		for(int d=1;d<b;d++){
			for(int e=1;e<b;e++){
				unit(p1+a,maprevealer,c+(map-c*2)/b*d,c+(map-c*2)/b*e,0,0,0,0,0,0);
			}
		}
	}

	//start
	trig(1<<p1);
	removeunit(f1,maprevealer);
	for(int a=0;a<6;a++){
		giveunitstoplayer(current,zergling,p7-a,11,anywhere);
	}
	removeunit(current,zergling);
	
	trig(1<<p1);
	elapsedtime(atleast,5);
	setdeaths(pall,dc_state,setto,0);

	//always
	trigp(1<<pall);
	for(int a=0;a<6;a++){
		char s[5];
		sprintf(s,"-Vi%d",p2+a);
		runaiscript(*(int32_t *)s);
	}
	modifyenergy(current,any,all,anywhere,0);
	setdeaths(current,dc_rand,setto,0);
	for(int a=0;a<6;a++){
		setswitch(_rand[a],_random);
	}
	setdeaths(current,dc_grid[0][0],setto,0);
	setdeaths(current,dc_grid[1][0],setto,0);
	setdeaths(current,dc_grid[0][1],setto,0);
	setdeaths(current,dc_grid[1][1],setto,adj_y);
	for(int a=0;a<6;a++){
		trigp(1<<pall);
		_switch(_rand[a],isset);
		setdeaths(current,dc_rand,add,1<<a);
	}
	
	//init
	trigp(1<<p1);
	deaths(current,dc_state,exactly,0);
	for(int a=0;a<6;a++){
		for(int b=0;b<11;b++){
			if(11*a+b==64)break;
			removeunitatlocation(p7-a,any,1,anywhere);
		}
	}
	trigp(1<<p1);
	deaths(current,dc_state,exactly,0);
	for(int a=5;a<6;a++){
		for(int b=9;b<11;b++){
			removeunitatlocation(p7-a,any,1,anywhere);
		}
	}
	trigp(1<<f1);
	deaths(current,dc_state,exactly,0);
	muteunitspeech();
	leaderboardcomputerplayers(toclear);
	runaiscript(*(int32_t *)"+Vi0");
	trigp(1<<p1);
	deaths(current,dc_state,exactly,1);
	createunit(current,marine,1,anywhere);
	removeunit(current,marine);
	//starting pos
	for(int a=0;a<6;a++){
		int32_t x=tile*73+(tile*3)*(a%2);
		int32_t y=tile*44-(tile*2)*a;
		uint8_t m=mrgn(x,y,x,y,0);
		trigp(1<<f1);
		deaths(current,dc_state,exactly,1);
		deaths(p1,dc_order,exactly,a);
		movelocation(p1,uncenter,m,gen[0]);
		setdeaths(current,dc_pos[0],setto,gran*(-space+x));
		setdeaths(current,dc_pos[1],setto,gran*(-space+y));
	}
	//create unit
	for(int a=0;a<7;a++){
		for(int b=0;b<5;b++){
			if(5*a+b>=32)break;
			trigp(1<<f1);
			deaths(current,dc_state,exactly,1);
			deaths(current,dc_rand,atleast,(5*a+b)<<1);
			deaths(current,dc_rand,atmost,((5*a+b+1)<<1)-1);
			createunitwithproperties(current,_units[a],1,gen[0],uprpp(100,0,0,0,10,invincible));
			if(indices[a]<11){
				createunit(current,marine,11-indices[a],anywhere);
				removeunit(current,marine);
			}
			displaytextmessagea(str(desc[a]));
			transmission(_units[a],gen[0],str(wavs[a][b]),setto,2000,0);
		}
	}
	for(int a=0;a<6;a++){
		trigp(1<<p2+a);
		deaths(current,dc_state,exactly,1);
		movelocation(p1,uncenter,gen[0],pos[a]);
		setdeaths(p1,dc_order,add,1);
		setdeaths(current,dc_dir,setto,1<<8*4-1);
		setdeaths(current,dc_speed_mag,setto,3);
		setdeaths(current,dc_speed[0],setto,0);
		setdeaths(current,dc_speed[1],setto,8);
	}
	
	trigp(1<<pall);
	deaths(current,dc_state,atmost,2-1);
	setdeaths(current,dc_state,add,1);

	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	setdeaths(current,dc_speed_mag,subtract,1);
	
	for(int a=0;a<2;a++){
		//transfer unit pos to grid unit/screen pos
		for(int b=0;b<10/2;b++){
			int c=10+2*(-1-b);
			int d=(3+3)+10+2*(-1-b);
			trigp(qc);
			deaths(current,dc_state,exactly,2);
			deaths(current,dc_pos[a],atleast,1<<d);
			setdeaths(current,dc_pos[a],subtract,1<<d);
			setdeaths(current,dc_grid[a][0],add,1<<c);
			setdeaths(current,dc_grid[a][1],add,1<<c);
			setdeaths(current,dc_temp[0],add,1<<c);
		}
		//restore unit pos
		for(int b=0;b<10/2;b++){
			int c=10+2*(-1-b);
			int d=(3+3)+10+2*(-1-b);
			trigp(qc);
			deaths(current,dc_state,exactly,2);
			deaths(current,dc_temp[0],atleast,1<<c);
			setdeaths(current,dc_temp[0],subtract,1<<c);
			setdeaths(current,dc_pos[a],add,1<<d);
		}
	}
	
	//adjust screen pos
	//pole
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,1<<dc_bits-1);
	setdeaths(current,dc_dir,subtract,1<<dc_bits-1);
	setswitch(sgen[0],toset);
	//complement dir
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,1<<dc_bits-2);
	setdeaths(current,dc_dir,subtract,1<<dc_bits-2);
	setdeaths(current,dc_temp[0],setto,1<<dc_bits-2);
	setswitch(sgen[1],toset);
	for(int a=0;a<6/2;a++){
		int b=6+2*(-1-a);
		int c=(dc_bits-2-5)+6+2*(-1-a);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[1],isset);
		deaths(current,dc_dir,atleast,1<<c);
		setdeaths(current,dc_dir,subtract,1<<c);
		setdeaths(current,dc_temp[0],subtract,1<<c);
		setdeaths(current,dc_temp[2],add,1<<b);
	}
	for(int a=0;a<6/2;a++){
		int b=(dc_bits-2-5)+6+2*(-1-a);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[1],isset);
		deaths(current,dc_temp[0],atleast,1<<b);
		setdeaths(current,dc_temp[0],subtract,1<<b);
		setdeaths(current,dc_dir,add,1<<b);
	}
	
	int32_t i[2]={tile/accu*9,tile/accu*4};
	for(int a=0;a<angle/8+1;a++){
		trigp(1<<f1);
		deaths(current,dc_state,exactly,2);
		deaths(current,dc_dir,atleast,a<<(dc_bits-2-5));
		deaths(current,dc_dir,atmost,(a+1)<<(dc_bits-2-5));
		setdeaths(current,dc_temp[0],setto,(int32_t)floor(i[0]*tan(2*PI*a/angle)+0.5));
		setdeaths(current,dc_temp[1],setto,i[1]);
	}
	for(int a=angle/8+1;a<angle/4+1;a++){
		trigp(1<<f1);
		deaths(current,dc_state,exactly,2);
		deaths(current,dc_dir,atleast,a<<(dc_bits-2-5));
		deaths(current,dc_dir,atmost,(a+1)<<(dc_bits-2-5));
		setdeaths(current,dc_temp[0],setto,i[0]);
		setdeaths(current,dc_temp[1],setto,(int32_t)floor(i[1]/tan(2*PI*a/angle)+0.5));
	}
	//restore dir
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	_switch(sgen[1],isset);
	setdeaths(current,dc_dir,setto,1<<(dc_bits-2));
	for(int a=0;a<6/2;a++){
		int b=6+2*(-1-a);
		int c=(dc_bits-2-5)+6+2*(-1-a);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[1],isset);
		deaths(current,dc_temp[2],atleast,1<<b);
		setdeaths(current,dc_temp[2],subtract,1<<b);
		setdeaths(current,dc_dir,add,1<<c);
	}
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	_switch(sgen[0],isset);
	setdeaths(current,dc_dir,add,1<<dc_bits-1);
	setswitch(sgen[1],toggle);
	
	//add temps to grid screen
	int b[2]={6,4};
	for(int c=0;c<6/2;c++){
		int d=6+2*(-1-c);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isclear);
		deaths(current,dc_temp[0],atleast,1<<d);
		setdeaths(current,dc_temp[0],subtract,1<<d);
		setdeaths(current,dc_grid[0][1],add,1<<d);
	}
	for(int c=0;c<6/2;c++){
		int d=6+2*(-1-c);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isset);
		deaths(current,dc_temp[0],atleast,1<<d);
		setdeaths(current,dc_temp[0],subtract,1<<d);
		setdeaths(current,dc_grid[0][1],subtract,1<<d);
	}
	for(int c=0;c<4/2;c++){
		int d=4+2*(-1-c);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[1],isclear);
		deaths(current,dc_temp[1],atleast,1<<d);
		setdeaths(current,dc_temp[1],subtract,1<<d);
		setdeaths(current,dc_grid[1][1],subtract,1<<d);
	}
	for(int c=0;c<4/2;c++){
		int d=4+2*(-1-c);
		trigp(qc);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[1],isset);
		deaths(current,dc_temp[1],atleast,1<<d);
		setdeaths(current,dc_temp[1],subtract,1<<d);
		setdeaths(current,dc_grid[1][1],add,1<<d);
	}
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	setswitch(sgen[0],toclear);
	setswitch(sgen[1],toclear);
	
	//location grid units
	for(int a=0;a<area/accu;a++){
		unit(p9,gridunit,space+accu/2+accu*a,map-64,0,0,0,0,0,0);
	}
	//location grid
	for(int a=0;a<3;a++){
		int r=a==2?1:0;
		//location grid x
		for(int b=0;b<4;b++){
			trigp(1<<pall);
			if(b>0){
				deaths(current,dc_grid[0][a],atleast,area/accu/4*b);
			}
			if(b<4-1){
				deaths(current,dc_grid[0][a],atmost,area/accu/4*(b+1)-1);
			}
			if(b>0){
				setdeaths(current,dc_grid[0][a],subtract,area/accu/4*b);
				if(r){
					setdeaths(current,dc_temp[1],add,area/accu/4*b);
				}
			}
			movelocation(p1,uncenter,grid_x_static[b],gen[0]);
			setdeaths(current,dc_temp[0],setto,area/accu/4-1);
		}
		for(int b=0;b<8/2;b++){
			int c=8+2*(-1-b);
			trigp(qc);
			deaths(current,dc_grid[0][a],atleast,1<<c);
			setdeaths(current,dc_grid[0][a],subtract,1<<c);
			setdeaths(current,dc_temp[0],subtract,1<<c);
			if(r){
				setdeaths(current,dc_temp[1],add,1<<c);
			}
		}
		for(int b=0;b<8/2;b++){
			int c=8+2*(-1-b);
			trigp(qc);
			deaths(current,dc_temp[0],atleast,1<<c);
			setdeaths(current,dc_temp[0],subtract,1<<c);
			movelocation(p1,uncenter,gen[0],grid_x[3-b]);
			movelocation(p9,gridunit,grid_x[3-b],gen[0]);
		}
		if(r){
			for(int b=0;b<10/2;b++){
				int c=10+2*(-1-b);
				trigp(qc);
				deaths(current,dc_temp[1],atleast,1<<c);
				setdeaths(current,dc_temp[1],subtract,1<<c);
				setdeaths(current,dc_grid[0][a],add,1<<c);
			}
		}
		//location grid y handle shift
		trigp(1<<pall);
		deaths(current,dc_grid[1][a],atmost,area/accu/2-1);
		movelocation(p1,uncenter,gen[0],shift);
		movelocation(p1,uncenter,shift,gen[0]);
		setdeaths(current,dc_temp[0],setto,area/accu-1);
		setswitch(sgen[0],toset);
		for(int b=0;b<8/2;b++){
			int c=8+2*(-1-b);
			trigp(qc);
			_switch(sgen[0],isset);
			deaths(current,dc_grid[1][a],atleast,1<<c);
			setdeaths(current,dc_grid[1][a],subtract,1<<c);
			setdeaths(current,dc_temp[0],subtract,1<<c);
			if(r){
				setdeaths(current,dc_temp[1],add,1<<c);
			}
		}
		for(int b=0;b<10/2;b++){
			int c=10-2*(1+b);
			trigp(qc);
			deaths(current,dc_temp[0],atleast,1<<c);
			setdeaths(current,dc_temp[0],subtract,1<<c);
			setdeaths(current,dc_grid[1][a],add,1<<c);
		}
		//location grid y
		for(int b=0;b<area/accu/2;b++){
			trigp(1<<pall);
			deaths(current,dc_grid[1][a],exactly,area/accu/2+b);
			movelocation(p1,uncenter,gen[0],grid_y[area/accu/2-(1+b)]);
			movelocation(p1,uncenter,grid_y[area/accu/2-(1+b)],gen[0]);
		}
		if(r){
			trigp(1<<pall);
			_switch(sgen[0],isset);
			setswitch(sgen[0],toclear);
			setdeaths(current,dc_grid[1][a],setto,0);
			for(int b=0;b<8/2;b++){
				int c=8+2*(-1-b);
				trigp(qc);
				deaths(current,dc_temp[1],atleast,1<<c);
				setdeaths(current,dc_temp[1],subtract,1<<c);
				setdeaths(current,dc_grid[1][a],add,1<<c);
			}
		}
		
		if(a==0){
			//trigp(1<<f1);
			//deaths(current,dc_state,exactly,2);
			//order(current,any,norm,gen[0],patrol);
		}else if(a==1){
			trigp(1<<f1);
			moveunit(current,wraith,1,anywhere,gen[0]);
			//centerview(gen[0]);
		}else if(a==2){
			//trigp(1<<p2);
			//moveunit(current,wraith,1,anywhere,gen[0]);
			//centerview(gen[0]);
		}
	}

	//hypers
	trigp(1<<p1);
	_switch(hyper,isset);
	wait(0);
	setswitch(hyper,toclear);
	trigp(1<<p8);
	wait(0);
	setswitch(hyper,toset);
	wait(0);
}